// (A) FILES TO CACHE
const cName = "v1",
cList = ["img-science.png", "img-not-found.png"];

// (B) ADD FILES INTO CACHE ON WORKER INSTALL
self.addEventListener("install", (evt) => {
  evt.waitUntil(
    caches.open(cName)
    .then((cache) => { return cache.addAll(cList); })
    .catch((err) => { console.log(err); })
  );
  console.log("Files cached");
});

// (C) "HIJACK" FETCH REQUESTS - CACHE STRATEGIES
self.addEventListener("fetch", (evt) => {
  // (C0) CURRENT FETCH REQUEST
  console.log(evt.request);

  // (C1) SERVE FROM CACHE ONLY
  // evt.respondWith(caches.match(evt.request));

  // (C2) SERVE FROM NETWORK ONLY
  // evt.respondWith(fetch(evt.request));

  /* (C3) NETWORK FIRST, FALLBACK TO CACHE
  evt.respondWith(
    fetch(evt.request)
    .catch(() => { return caches.match(evt.request); })
  );*/

  // (C4) LOAD FROM CACHE, FALLBACK TO NETWORK
  evt.respondWith(
    caches.match(evt.request)
    .then((res) => {
      if (res) { console.log("Serve cached"); }
      return res || fetch(evt.request);
    })
  );
});
