// (A) NEW V2 CACHE
const cName = "v2",
cList = ["img-science.png", "img-raspberry.png", "img-not-found.png"];

// (B) ADD FILES INTO CACHE ON WORKER INSTALL
self.addEventListener("install", (evt) => {
  evt.waitUntil(
    caches.open(cName)
    .then((cache) => { return cache.addAll(cList); })
    .catch((err) => { console.log(err); })
  );
  console.log("Files cached");
});

// (C) REMOVE ALL OLD CACHES
self.addEventListener("activate", (evt) => {
  var keep = ["v2"];
  evt.waitUntil(
    caches.keys().then((allCache) => {
      return Promise.all(allCache.map((key) => {
        if (keep.indexOf(key) === -1) { return caches.delete(key); }
      }));
    })
  );
});
