// (A) NOTHING TO "INSTALL" - SKIP WAITING
// MAKE WORKER IMMEDIATELY AVAILABLE
self.addEventListener("install", (evt) => {
  evt.waitUntil(self.skipWaiting());
});
self.addEventListener("activate", (evt) => {
  evt.waitUntil(self.clients.claim());
});

// (B) HANDLE MESSAGES
self.addEventListener("message", (evt) => {
  // (B1) MESSAGE RECEIVED
  console.log("Worker received message", evt);

  // (B2) WE CAN ALSO DETERMINE WHO IS THE SENDER
  var sender = evt.source.id;

  // (B3) FORWARD MESSAGE TO ALL CLIENTS
  self.clients.matchAll().then((all) => {
    all.forEach((client) => {
      client.postMessage(evt.data);
      // IF YOU WANT TO EXCLUDE THE SENDER
      // if (client != sender) { ... }
    });
  });
});
