// (A) OPEN "MYPROJECT" DATABASE
var idb = window.indexedDB,
    req = idb.open("MyProject");

// (B) ON DATABASE ERROR
req.onerror = (evt) => { console.log(evt); };

// (C) ON UPGRADE NEEDED (CREATE OR UPDATE DATABASE)
req.onupgradeneeded = (evt) => {
  // (C1) GET DATABASE
  idb = evt.target.result;
  idb.onerror = (evt) => { console.log(evt); };

  // (C2) CREATE STORE
  var store = idb.createObjectStore("Users", {
    keyPath: "id",
    autoIncrement: true
  });
  console.log("Database Created");
};

// (D) OPEN DATABASE OK
req.onsuccess = (evt) => {
  idb = evt.target.result;
  console.log("READY!");
};
