// (A) TRANSACTION HELPER FUNCTION
function tx () {
  return idb
    .transaction("Users", "readwrite")
    .objectStore("Users");
}

// (B) ADD NEW ENTRY
function add () {
  tx().add({
    name: "John Doe",
    email: "john@doe.com"
  });
  console.log("Added!");
}

// (C) PUT (UPDATE) AN ENTRY
function put () {
  tx().put({
    id: 1,
    name: "John Doezzz",
    email: "john@doe.com",
    gender : "male"
  });
  console.log("Updated");
}

// (D) GET (RETRIEVE) ENTRY
function get () {
  var req = tx().get(1);
  req.onsuccess = (evt) => {
    var john = req.result;
    console.log(john);
  };
}

// (E) DELETE ENTRY
function del () {
  var req = tx().delete(1);
  req.onsuccess = (evt) => {
    console.log("Deleted");
  };
}
