// (A) OPEN "MYPROJECT" DATABASE - NOTE : VERSION 2
var idb = window.indexedDB,
    req = idb.open("MyProject", 2);

// (B) ON DATABASE ERROR
req.onerror = (evt) => { console.log(evt); };

// (C) UPGRADE NEEDED (CREATE OR UPDATE DATABASE)
req.onupgradeneeded = (evt) => {
  // (C1) GET DATABASE
  idb = evt.target.result;
  idb.onerror = (evt) => { console.log(evt); };

  // (C2) VERSION 1 - CREATE "USER" STORE
  if (evt.oldVersion < 1) {
    var store = idb.createObjectStore("Users", {
      keyPath: "id",
      autoIncrement: true
    });
    console.log("Database Created");
  }

  // (C3) VERSION 2 - ADD INDEX "NAME", UNIQUE “EMAIL"
  if (evt.oldVersion < 2) {
    var store = req.transaction.objectStore("Users");
    store.createIndex("name", "name", { unique: false });
    store.createIndex("email", "email", { unique: true });
    // deleteIndex("NAME")
    // deleteObjectStore("NAME")
    console.log("Upgraded To V2");
  }
};

// (D) OPEN DATABASE OK
req.onsuccess = (evt) => {
  idb = evt.target.result;
  console.log("READY!");
};
