// (A) TRANSACTION HELPER FUNCTION
function tx () {
  return idb
    .transaction("Users", "readwrite")
    .objectStore("Users");
}

// (B) GENERATE DUMMY DATA
function dummy () {
  // (B1) DUMMY USERS
  var users = [
    {name: "Joa Doe", email: "joa@doe.com"},
    {name: "Job Doe", email: "job@doe.com"},
    {name: "Joc Doe", email: "joc@doe.com"},
    {name: "Joe Doe", email: "joe@doe.com"},
    {name: "Jon Doe", email: "jon@doe.com"}
  ];

  // (B2) ADD TO STORE
  var store = tx();
  for (let u of users) {
    store.add(u);
    console.log(u);
  }
}

// (C) GET BY NAME
function getName () {
  // (C1) GET "JON DOE"
  var req = tx().index("name").get("Jon Doe");

  // (C2) RESULT
  req.onsuccess = () => {
    console.log(req.result);
  };
}

// (D) GET BY EMAIL
function getEmail () {
  // (D1) GET "JOB@DOE.COM"
  var req = tx().index("email").get("job@doe.com");

  // (D2) RESULT
  req.onsuccess = () => {
    console.log(req.result);
  };
}
