// (A) REQUIRE MODULES
const fs = require("fs"), // FILE SYSTEM
      rl = require("readline"), // READ LINE
      https = require("https");

// (B) READ FILE (SYNC)
var data = fs.readFileSync("dummy.txt", "utf8");
console.log(data);

// (C) READ FILE (ASYNC)
fs.readFile("dummy.txt", "utf8", (err, data) => {
  console.log(data);
});

// (D) READ LINE-BY-LINE
const reader = rl.createInterface({
  input: fs.createReadStream("dummy.txt")
});
reader.on("line", (row) => {
  console.log(row);
});

// (E) GET FROM REMOTE SERVER
https.get("https://code-boxx.com", (res) => {
  res.on("data", (d) => {
    process.stdout.write(d);
  });
});
