// WEBSOCKET MODULE REQUIRED!
// https://github.com/websockets/ws
// npm install ws

// (A) CREATE WEBSOCKET SERVER AT PORT 8080
const ws = require("ws"),
      wss = new ws.Server({ port: 8080 });

// (B) ON CLIENT CONNECT
wss.on("connection", (socket, req) => {
  // (B1) SEND MESSAGE TO CLIENT
  socket.send("Welcome!");

  // (B2) ON RECEIVING MESSAGE FROM CLIENT
  socket.on("message", (msg) => {
    let message = msg.toString(); // MSG IS BUFFER OBJECT
    console.log(message);
  });

  // (B3) ON CLIENT DISCONNECT
  socket.on("close", (code, reason) => {
    console.log(code);
    console.log(reason);
  });
});

// (C) NOT-SO-CRITICAL EVENTS
wss.on("listening", () => { console.log("READY"); });
wss.on("close", () => { console.log("STOPPED"); });
wss.on("error", (err) => { console.log(err); });
