// (A) MODULES & SETTINGS
const express = require("express"),
      bodyParser = require("body-parser"),
      webpush = require("web-push"),
      mail = "your@email.com",
      port = 80,
      publicKey = "YOUR-PUBLIC-KEY",
      privateKey = "YOUR-PRIVATE-KEY";

// (B) SETUP SERVER
webpush.setVapidDetails("mailto:" + mail, publicKey, privateKey);
const app = express();
app.use(express.static(__dirname)); // SERVE STATIC FILES
app.use(bodyParser.json()); // JSON PARSER

// (C) SEND TEST PUSH NOTIFICATION
app.post("/mypush", (req, res) => {
  res.status(201).json({}); // REPLY WITH 201 (CREATED)
  webpush.sendNotification(req.body, JSON.stringify({
    title: "YES!",
    body: "It works!",
    icon: "note-potato.png",
    image: "note-banner.png"
  }))
  .catch((err) => { console.log(err); });
});

// (D) START!
app.listen(port, () => {
  console.log(`Server deployed at ${port}`)
});
