// (A) READABLE & WRITABLE STREAMS
const Stream = require("stream"),
      rStream = new Stream.Readable(),
      wStream = new Stream.Writable();

// (B) SET STREAMS TO ECHO DATA
// (B1) CONSUMER
rStream.on("data", (chunk) => {
  console.log("Read Stream", chunk.toString());
});
// (B2) SINK
wStream._write = (chunk, encoding, next) => {
  console.log("Write Stream", chunk.toString());
  next();
};

// (C) DUMB TEST - PIPE READ STREAM INTO WRITE
rStream.pipe(wStream);
rStream.push("Hello World!");

// (D) CLOSE STREAM
rStream.destroy();
