var voice = {
  // (A) INIT SPEECH RECOGNITION
  sfield : null, // HTML SEARCH FIELD
  sspeech : null, // HTML VOICE SEARCH BUTTON
  ssicon : null, // HTML VOICE SEARCH ICON
  recog : null, // SPEECH RECOGNITION OBJECT
  init : () => {
    // (A1) GET HTML ELEMENTS
    voice.sfield = document.getElementById("sfield");
    voice.sspeech = document.getElementById("sspeech");
    voice.ssicon = document.getElementById("ssicon");

    // (A2) GET MICROPHONE ACCESS
    navigator.mediaDevices.getUserMedia({ audio: true })
    .then((stream) => {
      // (A3) SPEECH RECOGNITION OBJECT + SETTINGS
      const SR = window.SpeechRecognition || window.webkitSpeechRecognition;
      voice.recog = new SR();
      voice.recog.lang = "en-US";
      voice.recog.continuous = false;
      voice.recog.interimResults = false;

      // (A4) POPUPLATE SEARCH FIELD ON SPEECH RECOGNITION
      voice.recog.onresult = (evt) => {
        let said = evt.results[0][0].transcript.toLowerCase();
        voice.sfield.value = said;
        voice.stop();
        // SUBMIT SEARCH FORM OR AJAX SEARCH IF YOU WANT
      };

      // (A5) ON SPEECH RECOGNITION ERROR
      voice.recog.onerror = (err) => { console.error(err); };

      // (A6) READY!
      voice.sspeech.disabled = false;
      voice.stop();
    })
    .catch((err) => { console.error(err); });
  },

  // (B) START SPEECH RECOGNITION
  start : () => {
    voice.recog.start();
    voice.sspeech.onclick = voice.stop;
    voice.ssicon.innerHTML = "record_voice_over";
  },

  // (C) STOP/CANCEL SPEECH RECOGNITION
  stop : () => {
    voice.recog.stop();
    voice.sspeech.onclick = voice.start;
    voice.ssicon.innerHTML = "mic";
  }
};
window.addEventListener("DOMContentLoaded", voice.init);
